/*
   h2c is released under GPL licence.
   Check file GPL.txt for more informations.
*/

OPT OSVERSION=37

ENUM ARG_COLOR, ARG_LIST, ARG_NOALIAS, ARG_STRICT
ENUM OK, BREAK, NOARGS
ENUM HTML, NHTML, ALIAS

DEF rd=NIL, args:PTR TO LONG, color[80]:STRING,
   coltab:PTR TO LONG, coltype:PTR TO LONG

PROC main() HANDLE
  VOID '$VER: h2c 1.0 (11.3.98) by Gabriele Favrin'

  args:=[0,0,0,0,0]
  coltype:=['W3C HTML', '', 'alias']

  WriteF('h2c 1.0 (11.3.98) by Gabriele Favrin (favrin@tin.it)\n\n')

  rd:=ReadArgs('COLOR,LS=LIST/S,NA=NOALIAS/S,S=STRICT/S', args, NIL)
  IF rd AND (args[ARG_COLOR] OR args[ARG_LIST])
    inittab()
    listColors()
  ELSE
    Raise(NOARGS)
  ENDIF

EXCEPT DO
  IF rd THEN FreeArgs(rd)

  IF (exception = NOARGS)
    WriteF('No valid args given.\n\n')
  ELSE
    WriteF('\n')
  ENDIF
ENDPROC

PROC listColors()
  DEF ct=0:REG, cols=0:REG, scols=0:REG, hex:REG, colorv:REG, found=0

  IF args[ARG_COLOR]
    hex,colorv:=prepareName()
  ENDIF

  WHILE coltab[ct]
    IF CtrlC() THEN Raise(BREAK)

    IF ((args[ARG_STRICT] = TRUE) AND (coltab[ct+2] <> HTML)) OR ((args[ARG_NOALIAS] = TRUE) AND (coltab[ct+2] = ALIAS))
      INC scols
    ELSE
      INC cols

      IF args[ARG_LIST]
        WriteF(' \l\s[22] #\z\r\h[6] \s\n', coltab[ct], coltab[ct+1], coltype[coltab[ct+2]])
      ELSE
        IF ((hex = TRUE) AND (colorv = coltab[ct+1])) OR ((hex = FALSE) AND (StrCmp(color, coltab[ct])))
          WriteF(' \l\s[22] #\z\r\h[6] \s\n', coltab[ct], coltab[ct+1], coltype[coltab[ct+2]])
          found:=TRUE
        ENDIF
      ENDIF
    ENDIF

    ct:=ct+3
  ENDWHILE

  IF args[ARG_LIST]
    WriteF('\nListed \d colors, \d skipped.\n', cols, scols)
  ELSEIF (found = FALSE)
    WriteF('Colour name not found.\n')
  ENDIF

ENDPROC

PROC prepareName()
  DEF lc:REG, r=0:REG, w=0:REG, colorv:REG, hex:REG

  StrCopy(color, args[ARG_COLOR])
  IF (color[] <> "#") AND (color[] <> "$")
    LowerStr(color)
    lc:=EstrLen(color)

    WHILE (r < lc)
      IF color[r] <> 32
        color[w]:=color[r]
        INC w
      ENDIF
      INC r
    ENDWHILE
    IF (w < lc) THEN color[w]:=0
    hex:=FALSE
  ELSE
    color[]:="$"
    colorv:=Val(color, NIL)
    hex:=TRUE
  ENDIF

ENDPROC hex, colorv

PROC inittab()
coltab:=['aliceblue',     $f0f8ff, NHTML,
      'antiquewhite',   $faebd7, NHTML,
      'antiquewhite1',    $ffefdb, NHTML,
      'antiquewhite2',    $eedfcc, NHTML,
      'antiquewhite3',    $cdc0b0, NHTML,
      'antiquewhite4',    $8b8378, NHTML,
      'aqua',         $00ffff, HTML,
      'aquamarine',     $7fffd4, NHTML,
      'aquamarine1',      $7fffd4, ALIAS,
      'aquamarine2',      $76eec6, NHTML,
      'aquamarine3',      $66cdaa, NHTML,
      'aquamarine4',      $458b74, NHTML,
      'azure',          $f0ffff, NHTML,
      'azure1',       $f0ffff, ALIAS,
      'azure2',       $e0eeee, NHTML,
      'azure3',       $c1cdcd, NHTML,
      'azure4',       $838b8b, NHTML,
      'beige',          $f5f5dc, NHTML,
      'bisque',       $ffe4c4, NHTML,
      'bisque1',        $ffe4c4, ALIAS,
      'bisque2',        $eed5b7, NHTML,
      'bisque3',        $cdb79e, NHTML,
      'bisque4',        $8b7d6b, NHTML,
      'black',          $000000, HTML,
      'blanchedalmond',   $ffebcd, NHTML,
      'blue',         $0000ff, HTML,
      'blue1',          $0000ff, ALIAS,
      'blue2',          $0000ee, NHTML,
      'blue3',          $0000cd, NHTML,
      'blue4',          $00008b, NHTML,
      'blueviolet',     $8a2be2, NHTML,
      'brown',          $a52a2a, NHTML,
      'brown1',       $ff4040, NHTML,
      'brown2',       $ee3b3b, NHTML,
      'brown3',       $cd3333, NHTML,
      'brown4',       $8b2323, NHTML,
      'burlywood',      $deb887, NHTML,
      'burlywood1',     $ffd39b, NHTML,
      'burlywood2',     $eec591, NHTML,
      'burlywood3',     $cdaa7d, NHTML,
      'burlywood4',     $8b7355, NHTML,
      'cadetblue',      $5f9ea0, NHTML,
      'cadetblue1',     $98f5ff, NHTML,
      'cadetblue2',     $8ee5ee, NHTML,
      'cadetblue3',     $7ac5cd, NHTML,
      'cadetblue4',     $53868b, NHTML,
      'chartreuse',     $7fff00, NHTML,
      'chartreuse1',      $7fff00, ALIAS,
      'chartreuse2',      $76ee00, NHTML,
      'chartreuse3',      $66cd00, NHTML,
      'chartreuse4',      $458b00, NHTML,
      'chocolate',      $d2691e, NHTML,
      'chocolate1',     $ff7f24, NHTML,
      'chocolate2',     $ee7621, NHTML,
      'chocolate3',     $cd661d, NHTML,
      'chocolate4',     $8b4513, NHTML,
      'coral',          $ff7f50, NHTML,
      'coral1',       $ff7256, NHTML,
      'coral2',       $ee6a50, NHTML,
      'coral3',       $cd5b45, NHTML,
      'coral4',       $8b3e2f, NHTML,
      'cornflowerblue',   $6495ed, NHTML,
      'cornsilk',       $fff8dc, NHTML,
      'cornsilk1',      $fff8dc, ALIAS,
      'cornsilk2',      $eee8cd, NHTML,
      'cornsilk3',      $cdc8b1, NHTML,
      'cornsilk4',      $8b8878, NHTML,
      'crimson',        $dc143c, NHTML,
      'cyan',         $00ffff, ALIAS,
      'cyan1',          $00ffff, ALIAS,
      'cyan2',          $00eeee, NHTML,
      'cyan3',          $00cdcd, NHTML,
      'cyan4',          $008b8b, NHTML,
      'darkblue',       $00008b, ALIAS,
      'darkcyan',       $008b8b, ALIAS,
      'darkgoldenrod',    $b8860b, NHTML,
      'darkgoldenrod1',   $ffb90f, NHTML,
      'darkgoldenrod2',   $eead0e, NHTML,
      'darkgoldenrod3',   $cd950c, NHTML,
      'darkgoldenrod4',   $8b6508, NHTML,
      'darkgray',       $a9a9a9, NHTML,
      'darkgrey',       $a9a9a9, ALIAS,
      'darkgreen',      $006400, NHTML,
      'darkkhaki',      $bdb76b, NHTML,
      'darkmagenta',      $8b008b, ALIAS,
      'darkolivegreen',   $556b2f, NHTML,
      'darkolivegreen1',  $caff70, NHTML,
      'darkolivegreen2',  $bcee68, NHTML,
      'darkolivegreen3',  $a2cd5a, NHTML,
      'darkolivegreen4',  $6e8b3d, NHTML,
      'darkorange',     $ff8c00, NHTML,
      'darkorange1',      $ff7f00, NHTML,
      'darkorange2',      $ee7600, NHTML,
      'darkorange3',      $cd6600, NHTML,
      'darkorange4',      $8b4500, NHTML,
      'darkorchid',     $9932cc, NHTML,
      'darkorchid1',      $bf3eff, NHTML,
      'darkorchid2',      $b23aee, NHTML,
      'darkorchid3',      $9a32cd, NHTML,
      'darkorchid4',      $68228b, NHTML,
      'darkred',        $8b0000, ALIAS,
      'darksalmon',     $e9967a, NHTML,
      'darkseagreen',   $8fbc8f, NHTML,
      'darkseagreen1',    $c1ffc1, NHTML,
      'darkseagreen2',    $b4eeb4, NHTML,
      'darkseagreen3',    $9bcd9b, NHTML,
      'darkseagreen4',    $698b69, NHTML,
      'darkslateblue',    $483d8b, NHTML,
      'darkslategray',    $2f4f4f, NHTML,
      'darkslategray1',   $97ffff, NHTML,
      'darkslategray2',   $8deeee, NHTML,
      'darkslategray3',   $79cdcd, NHTML,
      'darkslategray4',   $528b8b, NHTML,
      'darkslategrey',    $2f4f4f, ALIAS,
      'darkslategrey1',   $97ffff, ALIAS,
      'darkslategrey2',   $8deeee, ALIAS,
      'darkslategrey3',   $79cdcd, ALIAS,
      'darkslategrey4',   $528b8b, ALIAS,
      'darkturquoise',    $00ced1, NHTML,
      'darkviolet',     $9400d3, NHTML,
      'deeppink',       $ff1493, NHTML,
      'deeppink1',      $ff1493, ALIAS,
      'deeppink2',      $ee1289, NHTML,
      'deeppink3',      $cd1076, NHTML,
      'deeppink4',      $8b0a50, NHTML,
      'deepskyblue',      $00bfff, NHTML,
      'deepskyblue1',   $00bfff, ALIAS,
      'deepskyblue2',   $00b2ee, NHTML,
      'deepskyblue3',   $009acd, NHTML,
      'deepskyblue4',   $00688b, NHTML,
      'dimgray',        $696969, ALIAS,
      'dimgrey',        $696969, ALIAS,
      'dodgerblue',     $1e90ff, NHTML,
      'dodgerblue1',      $1e90ff, ALIAS,
      'dodgerblue2',      $1c86ee, NHTML,
      'dodgerblue3',      $1874cd, NHTML,
      'dodgerblue4',      $104e8b, NHTML,
      'firebrick',      $b22222, NHTML,
      'firebrick1',     $ff3030, NHTML,
      'firebrick2',     $ee2c2c, NHTML,
      'firebrick3',     $cd2626, NHTML,
      'firebrick4',     $8b1a1a, NHTML,
      'floralwhite',      $fffaf0, NHTML,
      'forestgreen',      $228b22, NHTML,
      'fuchsia',        $ff00ff, HTML,
      'gainsboro',      $dcdcdc, NHTML,
      'ghostwhite',     $f8f8ff, NHTML,
      'gold',         $ffd700, NHTML,
      'gold1',          $ffd700, ALIAS,
      'gold2',          $eec900, NHTML,
      'gold3',          $cdad00, NHTML,
      'gold4',          $8b7500, NHTML,
      'goldenrod',      $daa520, NHTML,
      'goldenrod1',     $ffc125, NHTML,
      'goldenrod2',     $eeb422, NHTML,
      'goldenrod3',     $cd9b1d, NHTML,
      'goldenrod4',     $8b6914, NHTML,
      'gray',         $808080, HTML,
      'gray0',          $000000, ALIAS,
      'gray1',          $030303, NHTML,
      'gray2',          $050505, NHTML,
      'gray3',          $080808, NHTML,
      'gray4',          $0a0a0a, NHTML,
      'gray5',          $0d0d0d, NHTML,
      'gray6',          $0f0f0f, NHTML,
      'gray7',          $121212, NHTML,
      'gray8',          $141414, NHTML,
      'gray9',          $171717, NHTML,
      'gray10',       $1a1a1a, NHTML,
      'gray11',       $1c1c1c, NHTML,
      'gray12',       $1f1f1f, NHTML,
      'gray13',       $212121, NHTML,
      'gray14',       $242424, NHTML,
      'gray15',       $262626, NHTML,
      'gray16',       $292929, NHTML,
      'gray17',       $2b2b2b, NHTML,
      'gray18',       $2e2e2e, NHTML,
      'gray19',       $303030, NHTML,
      'gray20',       $333333, NHTML,
      'gray21',       $363636, NHTML,
      'gray22',       $383838, NHTML,
      'gray23',       $3b3b3b, NHTML,
      'gray24',       $3d3d3d, NHTML,
      'gray25',       $404040, NHTML,
      'gray26',       $424242, NHTML,
      'gray27',       $454545, NHTML,
      'gray28',       $474747, NHTML,
      'gray29',       $4a4a4a, NHTML,
      'gray30',       $4d4d4d, NHTML,
      'gray31',       $4f4f4f, NHTML,
      'gray32',       $525252, NHTML,
      'gray33',       $545454, NHTML,
      'gray34',       $575757, NHTML,
      'gray35',       $595959, NHTML,
      'gray36',       $5c5c5c, NHTML,
      'gray37',       $5e5e5e, NHTML,
      'gray38',       $616161, NHTML,
      'gray39',       $636363, NHTML,
      'gray40',       $666666, NHTML,
      'gray41',       $696969, NHTML,
      'gray42',       $6b6b6b, NHTML,
      'gray43',       $6e6e6e, NHTML,
      'gray44',       $707070, NHTML,
      'gray45',       $737373, NHTML,
      'gray46',       $757575, NHTML,
      'gray47',       $787878, NHTML,
      'gray48',       $7a7a7a, NHTML,
      'gray49',       $7d7d7d, NHTML,
      'gray50',       $7f7f7f, NHTML,
      'gray51',       $828282, NHTML,
      'gray52',       $858585, NHTML,
      'gray53',       $878787, NHTML,
      'gray54',       $8a8a8a, NHTML,
      'gray55',       $8c8c8c, NHTML,
      'gray56',       $8f8f8f, NHTML,
      'gray57',       $919191, NHTML,
      'gray58',       $949494, NHTML,
      'gray59',       $969696, NHTML,
      'gray60',       $999999, NHTML,
      'gray61',       $9c9c9c, NHTML,
      'gray62',       $9e9e9e, NHTML,
      'gray63',       $a1a1a1, NHTML,
      'gray64',       $a3a3a3, NHTML,
      'gray65',       $a6a6a6, NHTML,
      'gray66',       $a8a8a8, NHTML,
      'gray67',       $ababab, NHTML,
      'gray68',       $adadad, NHTML,
      'gray69',       $b0b0b0, NHTML,
      'gray70',       $b3b3b3, NHTML,
      'gray71',       $b5b5b5, NHTML,
      'gray72',       $b8b8b8, NHTML,
      'gray73',       $bababa, NHTML,
      'gray74',       $bdbdbd, NHTML,
      'gray75',       $bfbfbf, NHTML,
      'gray76',       $c2c2c2, NHTML,
      'gray77',       $c4c4c4, NHTML,
      'gray78',       $c7c7c7, NHTML,
      'gray79',       $c9c9c9, NHTML,
      'gray80',       $cccccc, NHTML,
      'gray81',       $cfcfcf, NHTML,
      'gray82',       $d1d1d1, NHTML,
      'gray83',       $d4d4d4, NHTML,
      'gray84',       $d6d6d6, NHTML,
      'gray85',       $d9d9d9, NHTML,
      'gray86',       $dbdbdb, NHTML,
      'gray87',       $dedede, NHTML,
      'gray88',       $e0e0e0, NHTML,
      'gray89',       $e3e3e3, NHTML,
      'gray90',       $e5e5e5, NHTML,
      'gray91',       $e8e8e8, NHTML,
      'gray92',       $ebebeb, NHTML,
      'gray93',       $ededed, NHTML,
      'gray94',       $f0f0f0, NHTML,
      'gray95',       $f2f2f2, NHTML,
      'gray96',       $f5f5f5, NHTML,
      'gray97',       $f7f7f7, NHTML,
      'gray98',       $fafafa, NHTML,
      'gray99',       $fcfcfc, NHTML,
      'gray100',        $ffffff, ALIAS,
      'grey',         $808080, ALIAS,
      'grey0',          $000000, ALIAS,
      'grey1',          $030303, ALIAS,
      'grey2',          $050505, ALIAS,
      'grey3',          $080808, ALIAS,
      'grey4',          $0a0a0a, ALIAS,
      'grey5',          $0d0d0d, ALIAS,
      'grey6',          $0f0f0f, ALIAS,
      'grey7',          $121212, ALIAS,
      'grey8',          $141414, ALIAS,
      'grey9',          $171717, ALIAS,
      'grey10',       $1a1a1a, ALIAS,
      'grey11',       $1c1c1c, ALIAS,
      'grey12',       $1f1f1f, ALIAS,
      'grey13',       $212121, ALIAS,
      'grey14',       $242424, ALIAS,
      'grey15',       $262626, ALIAS,
      'grey16',       $292929, ALIAS,
      'grey17',       $2b2b2b, ALIAS,
      'grey18',       $2e2e2e, ALIAS,
      'grey19',       $303030, ALIAS,
      'grey20',       $333333, ALIAS,
      'grey21',       $363636, ALIAS,
      'grey22',       $383838, ALIAS,
      'grey23',       $3b3b3b, ALIAS,
      'grey24',       $3d3d3d, ALIAS,
      'grey25',       $404040, ALIAS,
      'grey26',       $424242, ALIAS,
      'grey27',       $454545, ALIAS,
      'grey28',       $474747, ALIAS,
      'grey29',       $4a4a4a, ALIAS,
      'grey30',       $4d4d4d, ALIAS,
      'grey31',       $4f4f4f, ALIAS,
      'grey32',       $525252, ALIAS,
      'grey33',       $545454, ALIAS,
      'grey34',       $575757, ALIAS,
      'grey35',       $595959, ALIAS,
      'grey36',       $5c5c5c, ALIAS,
      'grey37',       $5e5e5e, ALIAS,
      'grey38',       $616161, ALIAS,
      'grey39',       $636363, ALIAS,
      'grey40',       $666666, ALIAS,
      'grey41',       $696969, ALIAS,
      'grey42',       $6b6b6b, ALIAS,
      'grey43',       $6e6e6e, ALIAS,
      'grey44',       $707070, ALIAS,
      'grey45',       $737373, ALIAS,
      'grey46',       $757575, ALIAS,
      'grey47',       $787878, ALIAS,
      'grey48',       $7a7a7a, ALIAS,
      'grey49',       $7d7d7d, ALIAS,
      'grey50',       $7f7f7f, ALIAS,
      'grey51',       $828282, ALIAS,
      'grey52',       $858585, ALIAS,
      'grey53',       $878787, ALIAS,
      'grey54',       $8a8a8a, ALIAS,
      'grey55',       $8c8c8c, ALIAS,
      'grey56',       $8f8f8f, ALIAS,
      'grey57',       $919191, ALIAS,
      'grey58',       $949494, ALIAS,
      'grey59',       $969696, ALIAS,
      'grey60',       $999999, ALIAS,
      'grey61',       $9c9c9c, ALIAS,
      'grey62',       $9e9e9e, ALIAS,
      'grey63',       $a1a1a1, ALIAS,
      'grey64',       $a3a3a3, ALIAS,
      'grey65',       $a6a6a6, ALIAS,
      'grey66',       $a8a8a8, ALIAS,
      'grey67',       $ababab, ALIAS,
      'grey68',       $adadad, ALIAS,
      'grey69',       $b0b0b0, ALIAS,
      'grey70',       $b3b3b3, ALIAS,
      'grey71',       $b5b5b5, ALIAS,
      'grey72',       $b8b8b8, ALIAS,
      'grey73',       $bababa, ALIAS,
      'grey74',       $bdbdbd, ALIAS,
      'grey75',       $bfbfbf, ALIAS,
      'grey76',       $c2c2c2, ALIAS,
      'grey77',       $c4c4c4, ALIAS,
      'grey78',       $c7c7c7, ALIAS,
      'grey79',       $c9c9c9, ALIAS,
      'grey80',       $cccccc, ALIAS,
      'grey81',       $cfcfcf, ALIAS,
      'grey82',       $d1d1d1, ALIAS,
      'grey83',       $d4d4d4, ALIAS,
      'grey84',       $d6d6d6, ALIAS,
      'grey85',       $d9d9d9, ALIAS,
      'grey86',       $dbdbdb, ALIAS,
      'grey87',       $dedede, ALIAS,
      'grey88',       $e0e0e0, ALIAS,
      'grey89',       $e3e3e3, ALIAS,
      'grey90',       $e5e5e5, ALIAS,
      'grey91',       $e8e8e8, ALIAS,
      'grey92',       $ebebeb, ALIAS,
      'grey93',       $ededed, ALIAS,
      'grey94',       $f0f0f0, ALIAS,
      'grey95',       $f2f2f2, ALIAS,
      'grey96',       $f5f5f5, ALIAS,
      'grey97',       $f7f7f7, ALIAS,
      'grey98',       $fafafa, ALIAS,
      'grey99',       $fcfcfc, ALIAS,
      'grey100',        $ffffff, ALIAS,
      'green',          $008000, HTML,
      'green1',       $00ff00, ALIAS,
      'green2',       $00ee00, NHTML,
      'green3',       $00cd00, NHTML,
      'green4',       $008b00, NHTML,
      'greenyellow',      $adff2f, NHTML,
      'honeydew',       $f0fff0, NHTML,
      'honeydew1',      $f0fff0, ALIAS,
      'honeydew2',      $e0eee0, NHTML,
      'honeydew3',      $c1cdc1, NHTML,
      'honeydew4',      $838b83, NHTML,
      'hotpink',        $ff69b4, NHTML,
      'hotpink1',       $ff6eb4, NHTML,
      'hotpink2',       $ee6aa7, NHTML,
      'hotpink3',       $cd6090, NHTML,
      'hotpink4',       $8b3a62, NHTML,
      'indianred',      $cd5c5c, NHTML,
      'indianred1',     $ff6a6a, NHTML,
      'indianred2',     $ee6363, NHTML,
      'indianred3',     $cd5555, NHTML,
      'indianred4',     $8b3a3a, NHTML,
      'indigo',       $4B0082, NHTML,
      'ivory',          $fffff0, NHTML,
      'ivory1',       $fffff0, ALIAS,
      'ivory2',       $eeeee0, NHTML,
      'ivory3',       $cdcdc1, NHTML,
      'ivory4',       $8b8b83, NHTML,
      'khaki',          $f0e68c, NHTML,
      'khaki1',       $fff68f, NHTML,
      'khaki2',       $eee685, NHTML,
      'khaki3',       $cdc673, NHTML,
      'khaki4',       $8b864e, NHTML,
      'lavender',       $e6e6fa, NHTML,
      'lavenderblush',    $fff0f5, NHTML,
      'lavenderblush1',   $fff0f5, ALIAS,
      'lavenderblush2',   $eee0e5, NHTML,
      'lavenderblush3',   $cdc1c5, NHTML,
      'lavenderblush4',   $8b8386, NHTML,
      'lawngreen',      $7cfc00, NHTML,
      'lemonchiffon',   $fffacd, NHTML,
      'lemonchiffon1',    $fffacd, ALIAS,
      'lemonchiffon2',    $eee9bf, NHTML,
      'lemonchiffon3',    $cdc9a5, NHTML,
      'lemonchiffon4',    $8b8970, NHTML,
      'lightblue',      $add8e6, NHTML,
      'lightblue1',     $bfefff, NHTML,
      'lightblue2',     $b2dfee, NHTML,
      'lightblue3',     $9ac0cd, NHTML,
      'lightblue4',     $68838b, NHTML,
      'lightcoral',     $f08080, NHTML,
      'lightcyan',      $e0ffff, NHTML,
      'lightcyan1',     $e0ffff, ALIAS,
      'lightcyan2',     $d1eeee, NHTML,
      'lightcyan3',     $b4cdcd, NHTML,
      'lightcyan4',     $7a8b8b, NHTML,
      'lightgoldenrod',   $eedd82, NHTML,
      'lightgoldenrod1',  $ffec8b, NHTML,
      'lightgoldenrod2',  $eedc82, NHTML,
      'lightgoldenrod3',  $cdbe70, NHTML,
      'lightgoldenrod4',  $8b814c, NHTML,
      'lightgoldenrodyellow', $fafad2, NHTML,
      'lightgray',      $d3d3d3, NHTML,
      'lightgrey',      $d3d3d3, ALIAS,
      'lightgreen',     $90ee90, ALIAS,
      'lightpink',      $ffb6c1, NHTML,
      'lightpink1',     $ffaeb9, NHTML,
      'lightpink2',     $eea2ad, NHTML,
      'lightpink3',     $cd8c95, NHTML,
      'lightpink4',     $8b5f65, NHTML,
      'lightsalmon',      $ffa07a, NHTML,
      'lightsalmon1',   $ffa07a, ALIAS,
      'lightsalmon2',   $ee9572, NHTML,
      'lightsalmon3',   $cd8162, NHTML,
      'lightsalmon4',   $8b5742, NHTML,
      'lightseagreen',    $20b2aa, NHTML,
      'lightskyblue',   $87cefa, NHTML,
      'lightskyblue1',    $b0e2ff, NHTML,
      'lightskyblue2',    $a4d3ee, NHTML,
      'lightskyblue3',    $8db6cd, NHTML,
      'lightskyblue4',    $607b8b, NHTML,
      'lightslateblue',   $8470ff, NHTML,
      'lightslategray',   $778899, NHTML,
      'lightslategrey',   $778899, ALIAS,
      'lightsteelblue',   $b0c4de, NHTML,
      'lightsteelblue1',  $cae1ff, NHTML,
      'lightsteelblue2',  $bcd2ee, NHTML,
      'lightsteelblue3',  $a2b5cd, NHTML,
      'lightsteelblue4',  $6e7b8b, NHTML,
      'lightyellow',      $ffffe0, NHTML,
      'lightyellow1',   $ffffe0, ALIAS,
      'lightyellow2',   $eeeed1, NHTML,
      'lightyellow3',   $cdcdb4, NHTML,
      'lightyellow4',   $8b8b7a, NHTML,
      'lime',         $00ff00, HTML,
      'limegreen',      $32cd32, NHTML,
      'linen',          $faf0e6, NHTML,
      'magenta',        $ff00ff, ALIAS,
      'magenta1',       $ff00ff, ALIAS,
      'magenta2',       $ee00ee, NHTML,
      'magenta3',       $cd00cd, NHTML,
      'magenta4',       $8b008b, NHTML,
      'maroon',       $800000, HTML,
      'maroon1',        $ff34b3, NHTML,
      'maroon2',        $ee30a7, NHTML,
      'maroon3',        $cd2990, NHTML,
      'maroon4',        $8b1c62, NHTML,
      'mediumaquamarine', $66cdaa, ALIAS,
      'mediumblue',     $0000cd, ALIAS,
      'mediumorchid',   $ba55d3, NHTML,
      'mediumorchid1',    $e066ff, NHTML,
      'mediumorchid2',    $d15fee, NHTML,
      'mediumorchid3',    $b452cd, NHTML,
      'mediumorchid4',    $7a378b, NHTML,
      'mediumpurple',   $9370db, NHTML,
      'mediumpurple1',    $ab82ff, NHTML,
      'mediumpurple2',    $9f79ee, NHTML,
      'mediumpurple3',    $8968cd, NHTML,
      'mediumpurple4',    $5d478b, NHTML,
      'mediumseagreen',   $3cb371, NHTML,
      'mediumslateblue',  $7b68ee, NHTML,
      'mediumspringgreen',  $00fa9a, NHTML,
      'mediumturquoise',  $48d1cc, NHTML,
      'mediumvioletred',  $c71585, NHTML,
      'midnightblue',   $191970, NHTML,
      'mintcream',      $f5fffa, NHTML,
      'mistyrose',      $ffe4e1, NHTML,
      'mistyrose1',     $ffe4e1, ALIAS,
      'mistyrose2',     $eed5d2, NHTML,
      'mistyrose3',     $cdb7b5, NHTML,
      'mistyrose4',     $8b7d7b, NHTML,
      'moccasin',       $ffe4b5, NHTML,
      'navajowhite',      $ffdead, NHTML,
      'navajowhite1',   $ffdead, ALIAS,
      'navajowhite2',   $eecfa1, NHTML,
      'navajowhite3',   $cdb38b, NHTML,
      'navajowhite4',   $8b795e, NHTML,
      'navy',         $000080, HTML,
      'navyblue',       $000080, ALIAS,
      'oldlace',        $fdf5e6, NHTML,
      'olive',          $808000, HTML,
      'olivedrab',      $6b8e23, NHTML,
      'olivedrab1',     $c0ff3e, NHTML,
      'olivedrab2',     $b3ee3a, NHTML,
      'olivedrab3',     $9acd32, NHTML,
      'olivedrab4',     $698b22, NHTML,
      'orange',       $ffa500, NHTML,
      'orange1',        $ffa500, ALIAS,
      'orange2',        $ee9a00, NHTML,
      'orange3',        $cd8500, NHTML,
      'orange4',        $8b5a00, NHTML,
      'orangered',      $ff4500, NHTML,
      'orangered1',     $ff4500, ALIAS,
      'orangered2',     $ee4000, NHTML,
      'orangered3',     $cd3700, NHTML,
      'orangered4',     $8b2500, NHTML,
      'orchid',       $da70d6, NHTML,
      'orchid1',        $ff83fa, NHTML,
      'orchid2',        $ee7ae9, NHTML,
      'orchid3',        $cd69c9, NHTML,
      'orchid4',        $8b4789, NHTML,
      'palegoldenrod',    $eee8aa, NHTML,
      'palegreen',      $98fb98, NHTML,
      'palegreen1',     $9aff9a, NHTML,
      'palegreen2',     $90ee90, NHTML,
      'palegreen3',     $7ccd7c, NHTML,
      'palegreen4',     $548b54, NHTML,
      'paleturquoise',    $afeeee, NHTML,
      'paleturquoise1',   $bbffff, NHTML,
      'paleturquoise2',   $aeeeee, NHTML,
      'paleturquoise3',   $96cdcd, NHTML,
      'paleturquoise4',   $668b8b, NHTML,
      'palevioletred',    $db7093, NHTML,
      'palevioletred1',   $ff82ab, NHTML,
      'palevioletred2',   $ee799f, NHTML,
      'palevioletred3',   $cd6889, NHTML,
      'palevioletred4',   $8b475d, NHTML,
      'papayawhip',     $ffefd5, NHTML,
      'peachpuff',      $ffdab9, NHTML,
      'peachpuff1',     $ffdab9, ALIAS,
      'peachpuff2',     $eecbad, NHTML,
      'peachpuff3',     $cdaf95, NHTML,
      'peachpuff4',     $8b7765, NHTML,
      'peru',         $cd853f, ALIAS,
      'pink',         $ffc0cb, NHTML,
      'pink1',          $ffb5c5, NHTML,
      'pink2',          $eea9b8, NHTML,
      'pink3',          $cd919e, NHTML,
      'pink4',          $8b636c, NHTML,
      'plum',         $dda0dd, NHTML,
      'plum1',          $ffbbff, NHTML,
      'plum2',          $eeaeee, NHTML,
      'plum3',          $cd96cd, NHTML,
      'plum4',          $8b668b, NHTML,
      'powderblue',     $b0e0e6, NHTML,
      'purple',       $800080, HTML,
      'purple1',        $9b30ff, NHTML,
      'purple2',        $912cee, NHTML,
      'purple3',        $7d26cd, NHTML,
      'purple4',        $551a8b, NHTML,
      'red',          $ff0000, HTML,
      'red1',         $ff0000, ALIAS,
      'red2',         $ee0000, NHTML,
      'red3',         $cd0000, NHTML,
      'red4',         $8b0000, NHTML,
      'rosybrown',      $bc8f8f, NHTML,
      'rosybrown1',     $ffc1c1, NHTML,
      'rosybrown2',     $eeb4b4, NHTML,
      'rosybrown3',     $cd9b9b, NHTML,
      'rosybrown4',     $8b6969, NHTML,
      'royalblue',      $4169e1, NHTML,
      'royalblue1',     $4876ff, NHTML,
      'royalblue2',     $436eee, NHTML,
      'royalblue3',     $3a5fcd, NHTML,
      'royalblue4',     $27408b, NHTML,
      'saddlebrown',      $8b4513, ALIAS,
      'salmon',       $fa8072, NHTML,
      'salmon1',        $ff8c69, NHTML,
      'salmon2',        $ee8262, NHTML,
      'salmon3',        $cd7054, NHTML,
      'salmon4',        $8b4c39, NHTML,
      'sandybrown',     $f4a460, NHTML,
      'seagreen',       $2e8b57, NHTML,
      'seagreen1',      $54ff9f, NHTML,
      'seagreen2',      $4eee94, NHTML,
      'seagreen3',      $43cd80, NHTML,
      'seagreen4',      $2e8b57, ALIAS,
      'seashell',       $fff5ee, NHTML,
      'seashell1',      $fff5ee, ALIAS,
      'seashell2',      $eee5de, NHTML,
      'seashell3',      $cdc5bf, NHTML,
      'seashell4',      $8b8682, NHTML,
      'sgibeet',        $8e388e, NHTML,
      'sgibrightgray',    $c5c1aa, NHTML,
      'sgibrightgrey',    $c5c1aa, ALIAS,
      'sgichartreuse',    $71c671, NHTML,
      'sgidarkgray',      $555555, NHTML,
      'sgidarkgrey',      $555555, ALIAS,
      'sgigray0',       $000000, ALIAS,
      'sgigray4',       $0a0a0a, ALIAS,
      'sgigray8',       $141414, ALIAS,
      'sgigray12',      $1e1e1e, NHTML,
      'sgigray16',      $282828, NHTML,
      'sgigray20',      $333333, ALIAS,
      'sgigray24',      $3d3d3d, ALIAS,
      'sgigray28',      $474747, ALIAS,
      'sgigray32',      $515151, NHTML,
      'sgigray36',      $5b5b5b, NHTML,
      'sgigray40',      $666666, ALIAS,
      'sgigray44',      $707070, ALIAS,
      'sgigray48',      $7a7a7a, ALIAS,
      'sgigray52',      $848484, NHTML,
      'sgigray56',      $8e8e8e, NHTML,
      'sgigray60',      $999999, ALIAS,
      'sgigray64',      $a3a3a3, ALIAS,
      'sgigray68',      $adadad, ALIAS,
      'sgigray72',      $b7b7b7, NHTML,
      'sgigray76',      $c1c1c1, NHTML,
      'sgigray80',      $cccccc, ALIAS,
      'sgigray84',      $d6d6d6, ALIAS,
      'sgigray88',      $e0e0e0, ALIAS,
      'sgigray92',      $eaeaea, NHTML,
      'sgigray96',      $f4f4f4, NHTML,
      'sgigray100',     $ffffff, ALIAS,
      'sgigrey0',       $000000, ALIAS,
      'sgigrey4',       $0a0a0a, ALIAS,
      'sgigrey8',       $141414, ALIAS,
      'sgigrey12',      $1e1e1e, ALIAS,
      'sgigrey16',      $282828, ALIAS,
      'sgigrey20',      $333333, ALIAS,
      'sgigrey24',      $3d3d3d, ALIAS,
      'sgigrey28',      $474747, ALIAS,
      'sgigrey32',      $515151, ALIAS,
      'sgigrey36',      $5b5b5b, ALIAS,
      'sgigrey40',      $666666, ALIAS,
      'sgigrey44',      $707070, ALIAS,
      'sgigrey48',      $7a7a7a, ALIAS,
      'sgigrey52',      $848484, ALIAS,
      'sgigrey56',      $8e8e8e, ALIAS,
      'sgigrey60',      $999999, ALIAS,
      'sgigrey64',      $a3a3a3, ALIAS,
      'sgigrey68',      $adadad, ALIAS,
      'sgigrey72',      $b7b7b7, ALIAS,
      'sgigrey76',      $c1c1c1, ALIAS,
      'sgigrey80',      $cccccc, ALIAS,
      'sgigrey84',      $d6d6d6, ALIAS,
      'sgigrey88',      $e0e0e0, ALIAS,
      'sgigrey92',      $eaeaea, ALIAS,
      'sgigrey96',      $f4f4f4, ALIAS,
      'sgigrey100',     $ffffff, ALIAS,
      'sgilightblue',   $7d9ec0, NHTML,
      'sgilightgray',   $aaaaaa, NHTML,
      'sgilightgrey',   $aaaaaa, ALIAS,
      'sgimediumgray',    $848484, ALIAS,
      'sgimediumgrey',    $848484, ALIAS,
      'sgiolivedrab',   $8e8e38, NHTML,
      'sgisalmon',      $c67171, NHTML,
      'sgislateblue',   $7171c6, NHTML,
      'sgiteal',        $388e8e, NHTML,
      'sgiverydarkgray',  $282828, NHTML,
      'sgiverydarkgrey',  $282828, ALIAS,
      'sgiverylightgray', $d6d6d6, ALIAS,
      'sgiverylightgrey', $d6d6d6, ALIAS,
      'sienna',       $a0522d, NHTML,
      'sienna1',        $ff8247, NHTML,
      'sienna2',        $ee7942, NHTML,
      'sienna3',        $cd6839, NHTML,
      'sienna4',        $8b4726, NHTML,
      'silver',       $c0c0c0, HTML,
      'skyblue',        $87ceeb, NHTML,
      'skyblue1',       $87ceff, NHTML,
      'skyblue2',       $7ec0ee, NHTML,
      'skyblue3',       $6ca6cd, NHTML,
      'skyblue4',       $4a708b, NHTML,
      'slateblue',      $6a5acd, NHTML,
      'slateblue1',     $836fff, NHTML,
      'slateblue2',     $7a67ee, NHTML,
      'slateblue3',     $6959cd, NHTML,
      'slateblue4',     $473c8b, NHTML,
      'slategray',      $708090, NHTML,
      'slategray1',     $c6e2ff, NHTML,
      'slategray2',     $b9d3ee, NHTML,
      'slategray3',     $9fb6cd, NHTML,
      'slategray4',     $6c7b8b, NHTML,
      'slategrey',      $708090, ALIAS,
      'slategrey1',     $c6e2ff, ALIAS,
      'slategrey2',     $b9d3ee, ALIAS,
      'slategrey3',     $9fb6cd, ALIAS,
      'slategrey4',     $6c7b8b, ALIAS,
      'snow',         $fffafa, NHTML,
      'snow1',          $fffafa, ALIAS,
      'snow2',          $eee9e9, NHTML,
      'snow3',          $cdc9c9, NHTML,
      'snow4',          $8b8989, NHTML,
      'springgreen',      $00ff7f, NHTML,
      'springgreen1',   $00ff7f, ALIAS,
      'springgreen2',   $00ee76, NHTML,
      'springgreen3',   $00cd66, NHTML,
      'springgreen4',   $008b45, NHTML,
      'steelblue',      $4682b4, NHTML,
      'steelblue1',     $63b8ff, NHTML,
      'steelblue2',     $5cacee, NHTML,
      'steelblue3',     $4f94cd, NHTML,
      'steelblue4',     $36648b, NHTML,
      'tan',          $d2b48c, NHTML,
      'tan1',         $ffa54f, NHTML,
      'tan2',         $ee9a49, NHTML,
      'tan3',         $cd853f, NHTML,
      'tan4',         $8b5a2b, NHTML,
      'teal',         $008080, HTML,
      'thistle',        $d8bfd8, NHTML,
      'thistle1',       $ffe1ff, NHTML,
      'thistle2',       $eed2ee, NHTML,
      'thistle3',       $cdb5cd, NHTML,
      'thistle4',       $8b7b8b, NHTML,
      'tomato',       $ff6347, NHTML,
      'tomato1',        $ff6347, ALIAS,
      'tomato2',        $ee5c42, NHTML,
      'tomato3',        $cd4f39, NHTML,
      'tomato4',        $8b3626, NHTML,
      'turquoise',      $40e0d0, NHTML,
      'turquoise1',     $00f5ff, NHTML,
      'turquoise2',     $00e5ee, NHTML,
      'turquoise3',     $00c5cd, NHTML,
      'turquoise4',     $00868b, NHTML,
      'violet',       $ee82ee, NHTML,
      'violetred',      $d02090, NHTML,
      'violetred1',     $ff3e96, NHTML,
      'violetred2',     $ee3a8c, NHTML,
      'violetred3',     $cd3278, NHTML,
      'violetred4',     $8b2252, NHTML,
      'wheat',          $f5deb3, NHTML,
      'wheat1',       $ffe7ba, NHTML,
      'wheat2',       $eed8ae, NHTML,
      'wheat3',       $cdba96, NHTML,
      'wheat4',       $8b7e66, NHTML,
      'white',          $ffffff, HTML,
      'whitesmoke',     $f5f5f5, ALIAS,
      'yellow',       $ffff00, HTML,
      'yellow1',        $ffff00, ALIAS,
      'yellow2',        $eeee00, NHTML,
      'yellow3',        $cdcd00, NHTML,
      'yellow4',        $8b8b00, NHTML,
      'yellowgreen',      $9acd32, ALIAS,
      0,              0,      0]
ENDPROC
